/** ***** BEGIN LICENSE BLOCK *****
  *
  * FloatingProperties for Nvu.
  *
  * (c) Copyright Disruptive Innovations SARL 2005
  * All Rights Reserved.
  *
  * ***** END LICENSE BLOCK *****
***/

const FloatingWindowHandler =
{

  floatingPropsWindow: null,

  GetFloatingPropsWindow: function()
  {
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var enumerator = windowManagerInterface.getEnumerator( null );
    var appShell = Components.classes['@mozilla.org/appshell/appShellService;1'].getService();
    appShell = appShell.QueryInterface( Components.interfaces.nsIAppShellService );

    var nativeAppSupport = null;
    try {
      nativeAppSupport = appShell.nativeAppSupport;
    }
    catch ( ex ) {
    }

    while ( enumerator.hasMoreElements()  )
    {
       var domWindow = enumerator.getNext();
       if (("FloatingWindowHandler" in domWindow) && domWindow.FloatingWindowHandler.floatingPropsWindow)
         return domWindow.FloatingWindowHandler.floatingPropsWindow;          
    };
    return null;
  },

  SetFloatingPropsWindow: function(w)
  {
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var enumerator = windowManagerInterface.getEnumerator( null );
    var appShell = Components.classes['@mozilla.org/appshell/appShellService;1'].getService();
    appShell = appShell.QueryInterface( Components.interfaces.nsIAppShellService );

    var nativeAppSupport = null;
    try {
      nativeAppSupport = appShell.nativeAppSupport;
    }
    catch ( ex ) {
    }

    while ( enumerator.hasMoreElements()  )
    {
       var domWindow = enumerator.getNext();
       if (("FloatingWindowHandler" in domWindow))
       {
         domWindow.FloatingWindowHandler.floatingPropsWindow = w;
         domWindow.document.getElementById('cmd_floatingProps').setAttribute("checked", (w != null));
       }
    };
    return null;
  },

  goToggleFloatingProps: function (command)
  {
    var checked = document.getElementById(command).getAttribute("checked");
    // First, let's see if we have a floating pref window
    var w = this.GetFloatingPropsWindow();
    if (w)
    {
        this.SetFloatingPropsWindow(null);
        w.close();
    }
    else
    {
        w = window.openDialog("chrome://floatingprops/content/floatingProps.xul", "_blank", "chrome,close,titlebar,modal=no", "");
        this.SetFloatingPropsWindow(w);
    }
  },

  startup: function ()
  {
    // first, let's see if a floating props window already exists
    var w = this.GetFloatingPropsWindow();
    // if there's one, reuse it
    if (w)
      this.floatingPropsWindow = w;

    // now, let's register our processors
    AddProcessorNotifier(this.selectionChanged, kProcessorsWhenSelectionChanges);
    AddProcessorNotifier(this.editModeChanged,  kProcessorsWhenDisplayModeChanges);
  },

  RefreshFloatingPropsCommand: function (command)
  {
    var w = this.GetFloatingPropsWindow();
    if (w)
    {
      this.floatingPropsWindow = w;
      document.getElementById(command).setAttribute("checked", "true");
    }
  },

  selectionChanged: function(elt)
  {
    var w = FloatingWindowHandler.floatingPropsWindow;
    if (!w)
      return;
    if (w.isEnabled())
      w.selectionChanged(elt);
  },

  editModeChanged: function(mode)
  {
    var w = FloatingWindowHandler.floatingPropsWindow;
    if (!w)
      return;
    w.enableAll(!(mode == kDisplayModeSource));
  }
};

FloatingWindowHandler.startup();